/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the BillingItem type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &BillingItem{}

// BillingItem struct for BillingItem
type BillingItem struct {
	OrganizationId string `json:"organization_id"`
	Organization string `json:"organization"`
	ChannelId string `json:"channel_id"`
	Channel string `json:"channel"`
	GatewayId *string `json:"gateway_id,omitempty"`
	MessengerId *string `json:"messenger_id,omitempty"`
	Messenger *string `json:"messenger,omitempty"`
	Provider *string `json:"provider,omitempty"`
	Quantity *int32 `json:"quantity,omitempty"`
	ItemPrice *float32 `json:"item_price,omitempty"`
	Cost *float32 `json:"cost,omitempty"`
	Currency *string `json:"currency,omitempty"`
	Country *string `json:"country,omitempty"`
	Region *string `json:"region,omitempty"`
	ConversationType *string `json:"conversation_type,omitempty"`
	Type *string `json:"type,omitempty"`
}

// NewBillingItem instantiates a new BillingItem object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBillingItem(organizationId string, organization string, channelId string, channel string) *BillingItem {
	this := BillingItem{}
	this.OrganizationId = organizationId
	this.Organization = organization
	this.ChannelId = channelId
	this.Channel = channel
	return &this
}

// NewBillingItemWithDefaults instantiates a new BillingItem object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBillingItemWithDefaults() *BillingItem {
	this := BillingItem{}
	return &this
}

// GetOrganizationId returns the OrganizationId field value
func (o *BillingItem) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *BillingItem) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *BillingItem) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetOrganization returns the Organization field value
func (o *BillingItem) GetOrganization() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Organization
}

// GetOrganizationOk returns a tuple with the Organization field value
// and a boolean to check if the value has been set.
func (o *BillingItem) GetOrganizationOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Organization, true
}

// SetOrganization sets field value
func (o *BillingItem) SetOrganization(v string) {
	o.Organization = v
}

// GetChannelId returns the ChannelId field value
func (o *BillingItem) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *BillingItem) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *BillingItem) SetChannelId(v string) {
	o.ChannelId = v
}

// GetChannel returns the Channel field value
func (o *BillingItem) GetChannel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Channel
}

// GetChannelOk returns a tuple with the Channel field value
// and a boolean to check if the value has been set.
func (o *BillingItem) GetChannelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Channel, true
}

// SetChannel sets field value
func (o *BillingItem) SetChannel(v string) {
	o.Channel = v
}

// GetGatewayId returns the GatewayId field value if set, zero value otherwise.
func (o *BillingItem) GetGatewayId() string {
	if o == nil || IsNil(o.GatewayId) {
		var ret string
		return ret
	}
	return *o.GatewayId
}

// GetGatewayIdOk returns a tuple with the GatewayId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingItem) GetGatewayIdOk() (*string, bool) {
	if o == nil || IsNil(o.GatewayId) {
		return nil, false
	}
	return o.GatewayId, true
}

// HasGatewayId returns a boolean if a field has been set.
func (o *BillingItem) HasGatewayId() bool {
	if o != nil && !IsNil(o.GatewayId) {
		return true
	}

	return false
}

// SetGatewayId gets a reference to the given string and assigns it to the GatewayId field.
func (o *BillingItem) SetGatewayId(v string) {
	o.GatewayId = &v
}

// GetMessengerId returns the MessengerId field value if set, zero value otherwise.
func (o *BillingItem) GetMessengerId() string {
	if o == nil || IsNil(o.MessengerId) {
		var ret string
		return ret
	}
	return *o.MessengerId
}

// GetMessengerIdOk returns a tuple with the MessengerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingItem) GetMessengerIdOk() (*string, bool) {
	if o == nil || IsNil(o.MessengerId) {
		return nil, false
	}
	return o.MessengerId, true
}

// HasMessengerId returns a boolean if a field has been set.
func (o *BillingItem) HasMessengerId() bool {
	if o != nil && !IsNil(o.MessengerId) {
		return true
	}

	return false
}

// SetMessengerId gets a reference to the given string and assigns it to the MessengerId field.
func (o *BillingItem) SetMessengerId(v string) {
	o.MessengerId = &v
}

// GetMessenger returns the Messenger field value if set, zero value otherwise.
func (o *BillingItem) GetMessenger() string {
	if o == nil || IsNil(o.Messenger) {
		var ret string
		return ret
	}
	return *o.Messenger
}

// GetMessengerOk returns a tuple with the Messenger field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingItem) GetMessengerOk() (*string, bool) {
	if o == nil || IsNil(o.Messenger) {
		return nil, false
	}
	return o.Messenger, true
}

// HasMessenger returns a boolean if a field has been set.
func (o *BillingItem) HasMessenger() bool {
	if o != nil && !IsNil(o.Messenger) {
		return true
	}

	return false
}

// SetMessenger gets a reference to the given string and assigns it to the Messenger field.
func (o *BillingItem) SetMessenger(v string) {
	o.Messenger = &v
}

// GetProvider returns the Provider field value if set, zero value otherwise.
func (o *BillingItem) GetProvider() string {
	if o == nil || IsNil(o.Provider) {
		var ret string
		return ret
	}
	return *o.Provider
}

// GetProviderOk returns a tuple with the Provider field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingItem) GetProviderOk() (*string, bool) {
	if o == nil || IsNil(o.Provider) {
		return nil, false
	}
	return o.Provider, true
}

// HasProvider returns a boolean if a field has been set.
func (o *BillingItem) HasProvider() bool {
	if o != nil && !IsNil(o.Provider) {
		return true
	}

	return false
}

// SetProvider gets a reference to the given string and assigns it to the Provider field.
func (o *BillingItem) SetProvider(v string) {
	o.Provider = &v
}

// GetQuantity returns the Quantity field value if set, zero value otherwise.
func (o *BillingItem) GetQuantity() int32 {
	if o == nil || IsNil(o.Quantity) {
		var ret int32
		return ret
	}
	return *o.Quantity
}

// GetQuantityOk returns a tuple with the Quantity field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingItem) GetQuantityOk() (*int32, bool) {
	if o == nil || IsNil(o.Quantity) {
		return nil, false
	}
	return o.Quantity, true
}

// HasQuantity returns a boolean if a field has been set.
func (o *BillingItem) HasQuantity() bool {
	if o != nil && !IsNil(o.Quantity) {
		return true
	}

	return false
}

// SetQuantity gets a reference to the given int32 and assigns it to the Quantity field.
func (o *BillingItem) SetQuantity(v int32) {
	o.Quantity = &v
}

// GetItemPrice returns the ItemPrice field value if set, zero value otherwise.
func (o *BillingItem) GetItemPrice() float32 {
	if o == nil || IsNil(o.ItemPrice) {
		var ret float32
		return ret
	}
	return *o.ItemPrice
}

// GetItemPriceOk returns a tuple with the ItemPrice field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingItem) GetItemPriceOk() (*float32, bool) {
	if o == nil || IsNil(o.ItemPrice) {
		return nil, false
	}
	return o.ItemPrice, true
}

// HasItemPrice returns a boolean if a field has been set.
func (o *BillingItem) HasItemPrice() bool {
	if o != nil && !IsNil(o.ItemPrice) {
		return true
	}

	return false
}

// SetItemPrice gets a reference to the given float32 and assigns it to the ItemPrice field.
func (o *BillingItem) SetItemPrice(v float32) {
	o.ItemPrice = &v
}

// GetCost returns the Cost field value if set, zero value otherwise.
func (o *BillingItem) GetCost() float32 {
	if o == nil || IsNil(o.Cost) {
		var ret float32
		return ret
	}
	return *o.Cost
}

// GetCostOk returns a tuple with the Cost field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingItem) GetCostOk() (*float32, bool) {
	if o == nil || IsNil(o.Cost) {
		return nil, false
	}
	return o.Cost, true
}

// HasCost returns a boolean if a field has been set.
func (o *BillingItem) HasCost() bool {
	if o != nil && !IsNil(o.Cost) {
		return true
	}

	return false
}

// SetCost gets a reference to the given float32 and assigns it to the Cost field.
func (o *BillingItem) SetCost(v float32) {
	o.Cost = &v
}

// GetCurrency returns the Currency field value if set, zero value otherwise.
func (o *BillingItem) GetCurrency() string {
	if o == nil || IsNil(o.Currency) {
		var ret string
		return ret
	}
	return *o.Currency
}

// GetCurrencyOk returns a tuple with the Currency field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingItem) GetCurrencyOk() (*string, bool) {
	if o == nil || IsNil(o.Currency) {
		return nil, false
	}
	return o.Currency, true
}

// HasCurrency returns a boolean if a field has been set.
func (o *BillingItem) HasCurrency() bool {
	if o != nil && !IsNil(o.Currency) {
		return true
	}

	return false
}

// SetCurrency gets a reference to the given string and assigns it to the Currency field.
func (o *BillingItem) SetCurrency(v string) {
	o.Currency = &v
}

// GetCountry returns the Country field value if set, zero value otherwise.
func (o *BillingItem) GetCountry() string {
	if o == nil || IsNil(o.Country) {
		var ret string
		return ret
	}
	return *o.Country
}

// GetCountryOk returns a tuple with the Country field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingItem) GetCountryOk() (*string, bool) {
	if o == nil || IsNil(o.Country) {
		return nil, false
	}
	return o.Country, true
}

// HasCountry returns a boolean if a field has been set.
func (o *BillingItem) HasCountry() bool {
	if o != nil && !IsNil(o.Country) {
		return true
	}

	return false
}

// SetCountry gets a reference to the given string and assigns it to the Country field.
func (o *BillingItem) SetCountry(v string) {
	o.Country = &v
}

// GetRegion returns the Region field value if set, zero value otherwise.
func (o *BillingItem) GetRegion() string {
	if o == nil || IsNil(o.Region) {
		var ret string
		return ret
	}
	return *o.Region
}

// GetRegionOk returns a tuple with the Region field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingItem) GetRegionOk() (*string, bool) {
	if o == nil || IsNil(o.Region) {
		return nil, false
	}
	return o.Region, true
}

// HasRegion returns a boolean if a field has been set.
func (o *BillingItem) HasRegion() bool {
	if o != nil && !IsNil(o.Region) {
		return true
	}

	return false
}

// SetRegion gets a reference to the given string and assigns it to the Region field.
func (o *BillingItem) SetRegion(v string) {
	o.Region = &v
}

// GetConversationType returns the ConversationType field value if set, zero value otherwise.
func (o *BillingItem) GetConversationType() string {
	if o == nil || IsNil(o.ConversationType) {
		var ret string
		return ret
	}
	return *o.ConversationType
}

// GetConversationTypeOk returns a tuple with the ConversationType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingItem) GetConversationTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ConversationType) {
		return nil, false
	}
	return o.ConversationType, true
}

// HasConversationType returns a boolean if a field has been set.
func (o *BillingItem) HasConversationType() bool {
	if o != nil && !IsNil(o.ConversationType) {
		return true
	}

	return false
}

// SetConversationType gets a reference to the given string and assigns it to the ConversationType field.
func (o *BillingItem) SetConversationType(v string) {
	o.ConversationType = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *BillingItem) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingItem) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *BillingItem) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *BillingItem) SetType(v string) {
	o.Type = &v
}

func (o BillingItem) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o BillingItem) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["organization"] = o.Organization
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["channel"] = o.Channel
	if !IsNil(o.GatewayId) {
		toSerialize["gateway_id"] = o.GatewayId
	}
	if !IsNil(o.MessengerId) {
		toSerialize["messenger_id"] = o.MessengerId
	}
	if !IsNil(o.Messenger) {
		toSerialize["messenger"] = o.Messenger
	}
	if !IsNil(o.Provider) {
		toSerialize["provider"] = o.Provider
	}
	if !IsNil(o.Quantity) {
		toSerialize["quantity"] = o.Quantity
	}
	if !IsNil(o.ItemPrice) {
		toSerialize["item_price"] = o.ItemPrice
	}
	if !IsNil(o.Cost) {
		toSerialize["cost"] = o.Cost
	}
	if !IsNil(o.Currency) {
		toSerialize["currency"] = o.Currency
	}
	if !IsNil(o.Country) {
		toSerialize["country"] = o.Country
	}
	if !IsNil(o.Region) {
		toSerialize["region"] = o.Region
	}
	if !IsNil(o.ConversationType) {
		toSerialize["conversation_type"] = o.ConversationType
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	return toSerialize, nil
}

type NullableBillingItem struct {
	value *BillingItem
	isSet bool
}

func (v NullableBillingItem) Get() *BillingItem {
	return v.value
}

func (v *NullableBillingItem) Set(val *BillingItem) {
	v.value = val
	v.isSet = true
}

func (v NullableBillingItem) IsSet() bool {
	return v.isSet
}

func (v *NullableBillingItem) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBillingItem(val *BillingItem) *NullableBillingItem {
	return &NullableBillingItem{value: val, isSet: true}
}

func (v NullableBillingItem) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBillingItem) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


